Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 3211)
@@ -39,9 +39,23 @@
    LOGICAL , PUBLIC, PARAMETER ::   lk_zdfgls = .TRUE.   !: TKE vertical mixing flag
    !
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   en      !: now turbulent kinetic energy
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   mxln    !: now mixing length
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zwall   !: wall function
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ustars2 !: Squared surface velocity scale at T-points
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ustarb2 !: Squared bottom  velocity scale at T-points
+   !! DCSE_NEMO: does not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   en      !: now turbulent kinetic energy
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   en      !: now turbulent kinetic energy
+
+   !! DCSE_NEMO: does not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   mxln    !: now mixing length
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   mxln    !: now mixing length
+
+   !! DCSE_NEMO: does not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zwall   !: wall function
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zwall   !: wall function
+
+   !! DCSE_NEMO: does not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ustars2 !: Squared surface velocity scale at T-points
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ustars2 !: Squared surface velocity scale at T-points
+
+   !! DCSE_NEMO: does not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ustarb2 !: Squared bottom  velocity scale at T-points
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ustarb2 !: Squared bottom  velocity scale at T-points
 
    !                                         !!! ** Namelist  namzdf_gls  **
@@ -102,4 +116,13 @@
    REAL(wp) ::   rpsi3m, rpsi3p, rpp, rmm, rnn                    !     -           -           -        -
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+!! DCSE_NEMO: private module variables do not need their own directives file
+!FTRANS en mxln zwall :I :I :z
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -144,4 +167,8 @@
       USE wrk_nemo, ONLY: eps       => wrk_3d_4   ! dissipation rate
       USE wrk_nemo, ONLY: zwall_psi => wrk_3d_5   ! Wall function use in the wb case (ln_sigpsi.AND.ln_crban=T)
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS z_elem_a z_elem_b z_elem_c psi :I :I :z
+!FTRANS eb mxlb shear eps zwall_psi :I :I :z
       !
       INTEGER, INTENT(in) ::   kt ! ocean time step
@@ -169,8 +196,19 @@
             ! 
             ! surface friction 
+#if defined key_z_first
+            ustars2(ji,jj) = rau0r * taum(ji,jj) * tmask_1(ji,jj)
+#else
             ustars2(ji,jj) = rau0r * taum(ji,jj) * tmask(ji,jj,1)
+#endif
             !
             ! bottom friction (explicit before friction)
             ! Note that we chose here not to bound the friction as in dynbfr)
+#if defined key_z_first
+            ztx2 = (  bfrua(ji,jj)  * ub(ji,jj,mbku(ji,jj)) + bfrua(ji-1,jj) * ub(ji-1,jj,mbku(ji-1,jj))  )   &
+               & * ( 1._wp - 0.5_wp * umask_1(ji,jj) * umask_1(ji-1,jj)  )
+            zty2 = (  bfrva(ji,jj)  * vb(ji,jj,mbkv(ji,jj)) + bfrva(ji,jj-1) * vb(ji,jj-1,mbkv(ji,jj-1))  )   &
+               & * ( 1._wp - 0.5_wp * vmask_1(ji,jj) * vmask_1(ji,jj-1)  )
+            ustarb2(ji,jj) = SQRT( ztx2 * ztx2 + zty2 * zty2 ) * tmask_1(ji,jj)
+#else
             ztx2 = (  bfrua(ji,jj)  * ub(ji,jj,mbku(ji,jj)) + bfrua(ji-1,jj) * ub(ji-1,jj,mbku(ji-1,jj))  )   &
                & * ( 1._wp - 0.5_wp * umask(ji,jj,1) * umask(ji-1,jj,1)  )
@@ -178,4 +216,5 @@
                & * ( 1._wp - 0.5_wp * vmask(ji,jj,1) * vmask(ji,jj-1,1)  )
             ustarb2(ji,jj) = SQRT( ztx2 * ztx2 + zty2 * zty2 ) * tmask(ji,jj,1)
+#endif
          END DO
       END DO  
@@ -188,7 +227,13 @@
 
       ! Compute shear and dissipation rate
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                avmu(ji,jj,jk) = avmu(ji,jj,jk) * ( un(ji,jj,jk-1) - un(ji,jj,jk) )   &
                   &                            * ( ub(ji,jj,jk-1) - ub(ji,jj,jk) )   &
@@ -212,7 +257,13 @@
 
       IF( nn_clos == 0 ) THEN    ! Mellor-Yamada
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1 
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zup   = mxln(ji,jj,jk) * fsdepw(ji,jj,mbkt(ji,jj)+1)
                   zdown = vkarmn * fsdepw(ji,jj,jk) * ( -fsdepw(ji,jj,jk) + fsdepw(ji,jj,mbkt(ji,jj)+1) )
@@ -237,7 +288,13 @@
       ! Warning : after this step, en : right hand side of the matrix
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                !
                ! shear prod. at w-point weightened by mask
@@ -422,21 +479,39 @@
       ! ----------------------------------------------------------
       !
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1                       ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
+#else
       DO jk = 2, jpkm1                             ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                z_elem_b(ji,jj,jk) = z_elem_b(ji,jj,jk) - z_elem_a(ji,jj,jk) * z_elem_c(ji,jj,jk-1) / z_elem_b(ji,jj,jk-1)
             END DO
          END DO
       END DO
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpk                         ! Second recurrence : Lk = RHSk - Lk / Dk-1 * Lk-1
+#else
       DO jk = 2, jpk                               ! Second recurrence : Lk = RHSk - Lk / Dk-1 * Lk-1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                z_elem_a(ji,jj,jk) = en(ji,jj,jk) - z_elem_a(ji,jj,jk) / z_elem_b(ji,jj,jk-1) * z_elem_a(ji,jj,jk-1)
             END DO
          END DO
       END DO
-      DO jk = jpk-1, 2, -1                         ! thrid recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = jpk-1, 2, -1                   ! Third recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
+#else
+      DO jk = jpk-1, 2, -1                         ! Third recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                en(ji,jj,jk) = ( z_elem_a(ji,jj,jk) - z_elem_c(ji,jj,jk) * en(ji,jj,jk+1) ) / z_elem_b(ji,jj,jk)
             END DO
@@ -455,7 +530,13 @@
       !
       CASE( 0 )               ! k-kl  (Mellor-Yamada)
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   psi(ji,jj,jk)  = en(ji,jj,jk) * mxln(ji,jj,jk)
                END DO
@@ -464,7 +545,13 @@
          !
       CASE( 1 )               ! k-eps
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   psi(ji,jj,jk)  = eps(ji,jj,jk)
                END DO
@@ -473,7 +560,13 @@
          !
       CASE( 2 )               ! k-w
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   psi(ji,jj,jk)  = SQRT( en(ji,jj,jk) ) / ( rc0 * mxln(ji,jj,jk) )
                END DO
@@ -482,7 +575,13 @@
          !
       CASE( 3 )               ! generic
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   psi(ji,jj,jk)  = rc02 * en(ji,jj,jk) * mxln(ji,jj,jk)**rnn 
                END DO
@@ -499,7 +598,13 @@
       ! Warning : after this step, en : right hand side of the matrix
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                !
                ! psi / k
@@ -556,5 +661,9 @@
             !                      ! balance between the production and the dissipation terms including the wave effect
             zdep(:,:) = rl_sf * zhsro(:,:)
+#if defined key_z_first
+            psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask_1(:,:)
+#else
             psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask(:,:,1)
+#endif
             z_elem_a(:,:,1) = psi(:,:,1)
             z_elem_c(:,:,1) = 0._wp
@@ -565,5 +674,9 @@
             zex2 = (rmm*ra_sf)
             zdep(:,:) = ( (zhsro(:,:) + fsdepw(:,:,2))**zex1 ) / zhsro(:,:)**zex2
+#if defined key_z_first
+            psi (:,:,2) = rsbc_psi1 * ustars2(:,:)**rmm * zdep(:,:) * tmask_1(:,:)
+#else
             psi (:,:,2) = rsbc_psi1 * ustars2(:,:)**rmm * zdep(:,:) * tmask(:,:,1)
+#endif
             z_elem_a(:,:,2) = 0._wp
             z_elem_c(:,:,2) = 0._wp
@@ -575,5 +688,9 @@
             !
             zdep(:,:) = vkarmn * zhsro(:,:)
+#if defined key_z_first
+            psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask_1(:,:)
+#else
             psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask(:,:,1)
+#endif
             z_elem_a(:,:,1) = psi(:,:,1)
             z_elem_c(:,:,1) = 0._wp
@@ -582,5 +699,9 @@
             ! one level below
             zdep(:,:) = vkarmn * ( zhsro(:,:) + fsdepw(:,:,2) )
+#if defined key_z_first
+            psi (:,:,2) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask_1(:,:)
+#else
             psi (:,:,2) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask(:,:,1)
+#endif
             z_elem_a(:,:,2) = 0._wp
             z_elem_c(:,:,2) = 0._wp
@@ -594,5 +715,9 @@
             !
             zdep(:,:) = rl_sf * zhsro(:,:)
+#if defined key_z_first
+            psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask_1(:,:)
+#else
             psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask(:,:,1)
+#endif
             z_elem_a(:,:,1) = psi(:,:,1)
             z_elem_c(:,:,1) = 0._wp
@@ -612,5 +737,9 @@
             !
             zdep(:,:) = vkarmn * zhsro(:,:)
+#if defined key_z_first
+            psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask_1(:,:)
+#else
             psi (:,:,1) = rc0**rpp * en(:,:,1)**rmm * zdep(:,:)**rnn * tmask(:,:,1)
+#endif
             z_elem_a(:,:,1) = psi(:,:,1)
             z_elem_c(:,:,1) = 0._wp
@@ -693,21 +822,39 @@
       ! ----------------
       !
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1                       ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
+#else
       DO jk = 2, jpkm1                             ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                z_elem_b(ji,jj,jk) = z_elem_b(ji,jj,jk) - z_elem_a(ji,jj,jk) * z_elem_c(ji,jj,jk-1) / z_elem_b(ji,jj,jk-1)
             END DO
          END DO
       END DO
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpk                         ! Second recurrence : Lk = RHSk - Lk / Dk-1 * Lk-1
+#else
       DO jk = 2, jpk                               ! Second recurrence : Lk = RHSk - Lk / Dk-1 * Lk-1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                z_elem_a(ji,jj,jk) = psi(ji,jj,jk) - z_elem_a(ji,jj,jk) / z_elem_b(ji,jj,jk-1) * z_elem_a(ji,jj,jk-1)
             END DO
          END DO
       END DO
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = jpk-1, 2, -1                   ! Third recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
+#else
       DO jk = jpk-1, 2, -1                         ! Third recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                psi(ji,jj,jk) = ( z_elem_a(ji,jj,jk) - z_elem_c(ji,jj,jk) * psi(ji,jj,jk+1) ) / z_elem_b(ji,jj,jk)
             END DO
@@ -721,7 +868,13 @@
       !
       CASE( 0 )               ! k-kl  (Mellor-Yamada)
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   eps(ji,jj,jk) = rc03 * en(ji,jj,jk) * en(ji,jj,jk) * SQRT( en(ji,jj,jk) ) / psi(ji,jj,jk)
                END DO
@@ -730,7 +883,13 @@
          !
       CASE( 1 )               ! k-eps
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   eps(ji,jj,jk) = psi(ji,jj,jk)
                END DO
@@ -739,7 +898,13 @@
          !
       CASE( 2 )               ! k-w
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   eps(ji,jj,jk) = rc04 * en(ji,jj,jk) * psi(ji,jj,jk) 
                END DO
@@ -751,7 +916,13 @@
          zex1  =      ( 1.5_wp + rmm/rnn )
          zex2  = -1._wp / rnn
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+                DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   eps(ji,jj,jk) = zcoef * en(ji,jj,jk)**zex1 * psi(ji,jj,jk)**zex2
                END DO
@@ -763,7 +934,13 @@
       ! Limit dissipation rate under stable stratification
       ! --------------------------------------------------
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1 ! Note that this set boundary conditions on mxln at the same time
+#else
       DO jk = 1, jpkm1 ! Note that this set boundary conditions on mxln at the same time
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1    ! vector opt.
+#endif
                ! limitation
                eps(ji,jj,jk)  = MAX( eps(ji,jj,jk), rn_epsmin )
@@ -783,7 +960,13 @@
       !
       CASE ( 0 , 1 )             ! Galperin or Kantha-Clayson stability functions
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ! zcof =  l²/q²
                   zcof = mxlb(ji,jj,jk) * mxlb(ji,jj,jk) / ( 2._wp*eb(ji,jj,jk) )
@@ -804,7 +987,13 @@
          !
       CASE ( 2, 3 )               ! Canuto stability functions
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ! zcof =  l²/q²
                   zcof = mxlb(ji,jj,jk)*mxlb(ji,jj,jk) / ( 2._wp * eb(ji,jj,jk) )
@@ -850,4 +1039,13 @@
       ! Compute diffusivities/viscosities
       ! The computation below could be restrained to jk=2 to jpkm1 if GOTM style Dirichlet conditions are used
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpk
+#else
+      DO jk = 1, jpk
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
       DO jk = 1, jpk
          DO jj = 2, jpjm1
@@ -866,7 +1064,13 @@
       CALL lbc_lnk( avm, 'W', 1. )   ;   CALL lbc_lnk( avt, 'W', 1. )
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1      !* vertical eddy viscosity at u- and v-points
+#else
       DO jk = 2, jpkm1            !* vertical eddy viscosity at u- and v-points
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                avmu(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji+1,jj  ,jk) ) * umask(ji,jj,jk)
                avmv(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji  ,jj+1,jk) ) * vmask(ji,jj,jk)
@@ -887,5 +1091,14 @@
       !
    END SUBROUTINE zdf_gls
-
+      
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+!! DCSE_NEMO: private module variables do not need their own directives file
+!FTRANS en mxln zwall :I :I :z
 
    SUBROUTINE zdf_gls_init
@@ -907,6 +1120,6 @@
       USE trazdf_exp
       !
-      INTEGER ::   jk    ! dummy loop indices
-      REAL(wp)::   zcr   ! local scalar
+      INTEGER ::   ji, jj, jk    ! dummy loop indices
+      REAL(wp)::   zcr           ! local scalar
       !!
       NAMELIST/namzdf_gls/rn_emin, rn_epsmin, ln_length_lim, &
@@ -1175,4 +1388,16 @@
 
       !                                !* set vertical eddy coef. to the background value
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+               avt (ji,jj,jk) = avtb(jk) * tmask(ji,jj,jk)
+               avm (ji,jj,jk) = avmb(jk) * tmask(ji,jj,jk)
+               avmu(ji,jj,jk) = avmb(jk) * umask(ji,jj,jk)
+               avmv(ji,jj,jk) = avmb(jk) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpk
          avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
@@ -1181,4 +1406,5 @@
          avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
       END DO
+#endif
       !                              
       CALL gls_rst( nit000, 'READ' )   !* read or initialize all required files
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfini.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfini.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfini.F90	(revision 3211)
@@ -36,4 +36,12 @@
    PUBLIC   zdf_init   ! routine called by opa.F90
    
+   !! * Control permutation of array indices
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "zdftke_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
